## maas 2.0.0~beta3%2Bbzr4941

=== Makefile ===
python := python3.5

# pkg_resources makes some incredible noise about version numbers. They
# are not indications of bugs in MAAS so we silence them everywhere.
export PYTHONWARNINGS = \
  ignore:You have iterated over the result:RuntimeWarning:pkg_resources:

# Network activity can be suppressed by setting offline=true (or any
# non-empty string) at the command-line.
ifeq ($(offline),)
buildout := bin/buildout
else
buildout := bin/buildout buildout:offline=true
endif

# If offline has been selected, attempt to further block HTTP/HTTPS
# activity by setting bogus proxies in the environment.
ifneq ($(offline),)
export http_proxy := broken
export https_proxy := broken
endif

# Python enum modules.
py_enums := $(wildcard src/*/enum.py)
# JavaScript enum module (not modules).
js_enums := src/maasserver/static/js/enums.js
templates := $(shell find etc/maas/templates -type f)

# MAAS SASS stylesheets. The first input file (maas-styles.css) imports
# the others, so is treated specially in the target definitions.
scss_inputs := \
    src/maasserver/static/scss/maas-styles.scss \
    $(wildcard src/maasserver/static/scss/*/*.scss) \
    $(wildcard src/maasserver/static/scss/*/*/*.scss)
scss_output := src/maasserver/static/css/maas-styles.css

# Prefix commands with this when they need access to the database.
# Remember to add a dependency on bin/database from the targets in
# which those commands appear.
dbrun := bin/database --preserve run --

# Disable progress when running npm and warning log levels.
npm_install := NODE_ENV=production NPM_CONFIG_PROGRESS="false" npm install \
	--loglevel error --cache-min 600

# For things that care, postgresfixture for example, we always want to
# use the "maas" databases.
export PGDATABASE := maas

# For anything we start, we want to hint as to its root directory.
export MAAS_ROOT := $(CURDIR)/run

build: \
    bin/buildout \
    bin/database \
    bin/maas \
    bin/maas-rack \
    bin/maas-region \
    bin/twistd.rack \
    bin/twistd.region \
    bin/test.cli \
    bin/test.rack \
    bin/test.config \
    bin/test.region \
    bin/test.testing \
    bin/test.js \
    bin/test.e2e \
    bin/py bin/ipy \
    $(js_enums)

all: build doc

# Install all packages required for MAAS development & operation on
# the system. This may prompt for a password.
install-dependencies: release := $(shell lsb_release -c -s)
install-dependencies:
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    --no-install-recommends install $(shell sort -u \
	        $(addprefix required-packages/,base build dev doc $(release)) | sed '/^\#/d')
	sudo DEBIAN_FRONTEND=noninteractive apt-get -y \
	    purge $(shell sort -u required-packages/forbidden | sed '/^\#/d')

.bzrignore: FORCE
	LC_ALL=C.UTF-8 sort -f $@ --output $@

.gitignore: .bzrignore
	sed 's:^[.]/:/:' $^ > $@
	echo '/src/**/*.pyc' >> $@
	echo '/etc/**/*.pyc' >> $@

configure-buildout:
	utilities/configure-buildout

bin/buildout: bootstrap-buildout.py
	@utilities/configure-buildout --quiet
	$(python) bootstrap-buildout.py --allow-site-packages
	@touch --no-create $@  # Ensure it's newer than its dependencies.

bin/database: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install database
	@touch --no-create $@

bin/maas-region bin/twistd.region: \
    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install region
	@touch --no-create $@

bin/test.region: \
    bin/buildout buildout.cfg versions.cfg setup.py $(js_enums)
	$(buildout) install region-test
	@touch --no-create $@

bin/maas: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install cli
	@touch --no-create $@

bin/test.cli: bin/buildout buildout.cfg versions.cfg setup.py bin/maas
	$(buildout) install cli-test
	@touch --no-create $@

bin/test.js: bin/karma bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install js-test
	@touch --no-create $@

bin/test.e2e: bin/protractor bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install e2e-test
	@touch --no-create $@

# bin/maas-region is needed for South migration tests. bin/flake8 is
# needed for checking lint and bin/sass is needed for checking css.
bin/test.testing: \
    bin/maas-region bin/flake8 bin/sass bin/buildout \
    buildout.cfg versions.cfg setup.py
	$(buildout) install testing-test
	@touch --no-create $@

bin/maas-rack bin/twistd.rack: \
    bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install rack
	@touch --no-create $@

bin/test.rack: \
	  bin/buildout buildout.cfg versions.cfg setup.py bin/maas-rack
	$(buildout) install rack-test
	@touch --no-create $@

bin/test.config: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install config-test
	@touch --no-create $@

bin/flake8: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install flake8
	@touch --no-create $@

bin/sphinx bin/sphinx-build: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install sphinx
	@touch --no-create $@

bin/py bin/ipy: bin/buildout buildout.cfg versions.cfg setup.py
	$(buildout) install repl
	@touch --no-create bin/py bin/ipy

define karma-deps
  jasmine-core@2.4.1
  karma@0.13.19
  karma-chrome-launcher@0.2.2
  karma-firefox-launcher@0.1.7
  karma-jasmine@0.3.6
  karma-opera-launcher@0.3.0
  karma-phantomjs-launcher@0.2.3
  karma-failed-reporter@0.0.3
  phantomjs@1.9.19
endef

bin/karma: deps = $(strip $(karma-deps))
bin/karma: prefix = include/nodejs
bin/karma:
	@mkdir -p $(@D) $(prefix)
	$(npm_install) --prefix $(prefix) $(deps)
	@ln -srf $(prefix)/node_modules/karma/bin/karma $@

bin/protractor: prefix = include/nodejs
bin/protractor:
	@mkdir -p $(@D) $(prefix)
	$(npm_install) --prefix $(prefix) protractor@3.0.0
	@ln -srf $(prefix)/node_modules/protractor/bin/protractor $@

bin/sass: prefix = include/nodejs
bin/sass:
	@mkdir -p $(@D) $(prefix)
	$(npm_install) --prefix $(prefix) node-sass@3.4.2
	@ln -srf $(prefix)/node_modules/node-sass/bin/node-sass $@

define test-scripts
  bin/test.cli
  bin/test.rack
  bin/test.config
  bin/test.region
  bin/test.testing
  bin/test.js
endef

test: $(strip $(test-scripts))
	@bin/maas-region makemigrations --dry-run --exit && exit 1 ||:
	@$(RM) coverage.data
	@echo $^ | xargs --verbose -n1 env

test+coverage: export NOSE_WITH_COVERAGE = 1
test+coverage: test

coverage-report: coverage/index.html
	sensible-browser $< > /dev/null 2>&1 &

coverage.xml: coverage.data
	python3-coverage xml --include 'src/*' -o $@

coverage/index.html: coverage.data
	@$(RM) -r $(@D)
	python3-coverage html --include 'src/*' -d $(@D)

coverage.data:
	@$(error Use `$(MAKE) test+coverage` to generate coverage data, or invoke a \
            test script using the `--with-coverage` flag)

lint: lint-py lint-py-imports lint-js lint-doc lint-rst

pocketlint = $(call available,pocketlint,python-pocket-lint)

# XXX jtv 2014-02-25: Clean up this lint, then make it part of "make lint".
lint-css: sources = src/maasserver/static/css
lint-css:
	@find $(sources) -type f \
	    -print0 | xargs -r0 $(pocketlint) --max-length=120

# Python lint checks are time-intensive, so we run them in parallel.  It may
# make things matters worse if the files need to be read from disk, though, so
# this may need more tuning.
# The -n50 -P4 setting roughly doubled speed on a high-end system with SSD and
# all the files in cache.
lint-py: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
lint-py: bin/flake8
	@find $(sources) -name '*.py' \
	  ! -path '*/migrations/*' ! -path '*/south_migrations/*' \
	  ! -path 'src/provisioningserver/twisted/*' ! -path 'ez_setup.py' \
	  ! -path 'src/maasserver/data/*' -print0 \
	    | xargs -r0 -n50 -P4 bin/flake8 --ignore=E123,E402,E731 \
	    --config=/dev/null

# Statically check imports against policy.
lint-py-imports:
	@utilities/check-imports

lint-doc:
	@utilities/doc-lint

# JavaScript lint is checked in parallel for speed.  The -n20 -P4 setting
# worked well on a multicore SSD machine with the files cached, roughly
# doubling the speed, but it may need tuning for slower systems or cold caches.
lint-js: sources = src/maasserver/static/js
lint-js:
	@find $(sources) -type f ! -path '*/angular/3rdparty/*' \
	    '(' -name '*.html' -o -name '*.js' ')' -print0 \
		| xargs -r0 -n20 -P4 $(pocketlint)

# Apply automated formatting to all Python files.
format: sources = $(wildcard *.py contrib/*.py) src templates twisted utilities etc
format:
	@find $(sources) -name '*.py' -print0 | xargs -r0 utilities/format-imports

# Update copyright dates from version history. Try to avoid updating
# 3rd-party code by checking for "Canonical" or "MAAS" on the same line
# as the copyright header.
copyright:
	@bzr ls --versioned --recursive --kind=file --null | \
	    xargs -r0 egrep -iI 'copyright.*(canonical|maas)' -lZ | \
	    xargs -r0 bzr update-copyright --quiet --force-range

check: clean test

docs/api.rst: bin/maas-region src/maasserver/api/doc_handler.py syncdb
	bin/maas-region generate_api_doc > $@

sampledata: bin/maas-region bin/database syncdb
	$(dbrun) bin/maas-region generate_sample_data

doc: bin/sphinx docs/api.rst
	bin/sphinx

docs/_build/html/index.html: doc

doc-browse: docs/_build/html/index.html
	sensible-browser $< > /dev/null 2>&1 &

doc-with-versions: bin/sphinx docs/api.rst
	$(MAKE) -C docs/_build SPHINXOPTS="-A add_version_switcher=true" html

man: $(patsubst docs/man/%.rst,man/%,$(wildcard docs/man/*.rst))

man/%: docs/man/%.rst | bin/sphinx-build
	bin/sphinx-build -b man docs man $^

enums: $(js_enums)

$(js_enums): bin/py src/maasserver/utils/jsenums.py $(py_enums)
	bin/py -m maasserver.utils.jsenums $(py_enums) > $@

styles: bin/sass clean-styles $(scss_output)

$(scss_output): $(scss_inputs)
	bin/sass --include-path=src/maasserver/static/scss --output-style compressed $< -o $(dir $@)

clean-styles:
	$(RM) $(scss_output)

clean: stop clean-run
	$(MAKE) -C acceptance $@
	find . -type f -name '*.py[co]' -print0 | xargs -r0 $(RM)
	find . -type d -name '__pycache__' -print0 | xargs -r0 $(RM) -r
	find . -type f -name '*~' -print0 | xargs -r0 $(RM)
	find . -type f -name dropin.cache -print0 | xargs -r0 $(RM)
	$(RM) -r media/demo/* media/development
	$(RM) $(js_enums) $(js_enums).tmp
	$(RM) src/maasserver/data/templates.py
	$(RM) *.log
	$(RM) docs/api.rst
	$(RM) -r docs/_autosummary docs/_build
	$(RM) -r man/.doctrees
	$(RM) coverage.data coverage.xml
	$(RM) -r coverage
	$(RM) -r .hypothesis
	$(RM) -r bin include lib local
	$(RM) -r eggs develop-eggs
	$(RM) -r build dist logs/* parts
	$(RM) tags TAGS .installed.cfg
	$(RM) -r *.egg *.egg-info src/*.egg-info
	$(RM) -r services/*/supervise

# Be selective about what to remove from run and run-e2e.
define clean-run-template
find $(1) -depth ! -type d \
    ! -path $(1)/etc/maas/templates \
    ! -path $(1)/etc/maas/drivers.yaml \
    -print0 | xargs -r0 $(RM)
find $(1) -depth -type d \
    -print0 | xargs -r0 rmdir --ignore-fail-on-non-empty
endef

clean-run:
	$(call clean-run-template,run)
	$(call clean-run-template,run-e2e)

clean+db: clean
	while fuser db --kill -TERM; do sleep 1; done
	$(RM) -r db
	$(RM) .db.lock

distclean: clean
	$(warning 'distclean' is deprecated; use 'clean')

harness: bin/maas-region bin/database
	$(dbrun) bin/maas-region shell --settings=maas.demo

dbharness: bin/database
	bin/database --preserve shell

syncdb: bin/maas-region bin/database
	$(dbrun) bin/maas-region dbupgrade

define phony_targets
  build
  check
  clean
  clean+db
  clean-run
  clean-styles
  configure-buildout
  copyright
  coverage-report
  dbharness
  distclean
  doc
  doc-browse
  enums
  format
  harness
  install-dependencies
  lint
  lint-css
  lint-doc
  lint-js
  lint-py
  lint-py-imports
  lint-rst
  man
  print-%
  sampledata
  styles
  syncdb
  test
  test-migrations
  test+coverage
endef

#
# Development services.
#

service_names_region := database dns regiond regiond2 reloader
service_names_rack := rackd reloader
service_names_all := $(service_names_region) $(service_names_rack)

=== debian/control ===
Source: maas
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: debhelper (>= 8.1.0~),
               dh-apport,
               dh-python,
               dh-systemd,
               po-debconf,
               python3-all,
               python3-django,
               python3-setuptools,
               python3-twisted
Standards-Version: 3.9.7
X-Python3-Version: >= 3.5
Homepage: http://maas.io/

Package: maas
Architecture: all
Depends: maas-rack-controller (= ${binary:Version}),
         maas-region-controller (= ${binary:Version}),
         python3-django-maas (= ${binary:Version}),
         ${misc:Depends}
Description: "Metal as a Service" is a physical cloud and IPAM
 MAAS runs a software-defined data centre - it turns a collection of physical
 servers and switches into a bare metal cloud with full open source IP address
 management (IPAM) and instant provisioning on demand.
 .
 MAAS controls the servers through IPMI or another BMC or  converged chassis
 controller such as Cisco UCS. It provides a full inventory  of components,
 and can install Ubuntu, CentOS or Windows very fast on any  server under
 its control. It can also track and provide DHCP and DNS for other devices
 on the network.
 .
 MAAS handles VLANs and fabrics that span many trunked switches, as well as
 the routing-centric infrastructure typically used for large-scale OpenStack
 or other scale-out deployments. MAAS manages IP addresses and provides APIs
 for address assignment and release. MAAS can also allocate IP addresses for
 containers on machines, and release them when the machine is repurposed. MAAS
 provides PXE, DHCP, DNS and other low-level  services to ensure the cluster
 works smoothly.
 .
 MAAS works with any configuration system, and is recommended by the teams
 behind both Chef and Juju as a physical provisioning system.
 .
 MAAS provides:
 .
  * Hardware inventory of servers
  * Dynamic provisioning based on name or attributes such as disk, RAM, cores,
    nics, networking, gpu’s or architecture
  * DNS and DHCP as needed
  * PXE boot services
 .
 This package is a metapackage which installs all of the separate components
 of MAAS on a single machine.

Package: maas-common
Architecture: all
Depends: ${misc:Depends}
Breaks: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Replaces: maas ( <= 0.1+bzr1048+dfsg-0ubuntu1 )
Description: MAAS server common files
 This package contains the common files for any MAAS installation.

Package: maas-region-api
Architecture: all
Depends: apache2,
         bind9utils,
         iproute2,
         libjs-angularjs,
         libjs-yui3-full,
         libjs-yui3-min,
         maas-common (= ${binary:Version}),
         maas-proxy (= ${binary:Version}),
         python3-bson,
         python3-django,
         python3-django-maas (= ${binary:Version}),
         python3-django-piston3,
         python3-djorm-ext-pgarray,
         python3-maas-provisioningserver (= ${binary:Version}),
         python3-petname,
         python3-requests,
         rsyslog,
         ubuntu-cloudimage-keyring,
         ${misc:Depends},
         ${python3:Depends}
Conflicts: maas-region-controller-min
Replaces: maas-region-controller-min
Provides: maas-region-controller-min
Description: Region controller API service for MAAS
 The MAAS region controller consists of REST API services and a postgres
 database. This package installs only the API services (maas-regiond).
 Use it to scale out the API front-end of your MAAS region controller.

Package: maas-region-controller
Architecture: all
Depends: dbconfig-pgsql,
         maas-dns (= ${binary:Version}),
         maas-region-api (= ${binary:Version}),
         postgresql (>= 9.1),
         ${misc:Depends},
Recommends: openssh-server
Description: Region Controller for MAAS
 The MAAS region controller (maas-regiond) is the REST API server for
 all MAAS clients, and the postgres database that maintains machine
 state for the entire data centre (or “region”). The region controller 
 an be scaled-out and highly available given the appropriate postgres
 setup and additional API servers.
 .
 This package installs the postgres database and the API server, so it
 is appropriate for the initial installation of a new MAAS region. To
 scale out the controller or make it highly available, install
 maas-region-controller-api on additional servers and ensure the
 postgres database is HA too.

Package: python3-maas-provisioningserver
Section: python
Architecture: all
Depends: archdetect-deb,
         lshw,
         python3-bson,
         python3-crochet,
         python3-curtin (>> 0.1.0~bzr351),
         python3-distro-info,
         python3-formencode,
         python3-jsonschema,
         python3-lxml,
         python3-maas-client (= ${binary:Version}),
         python3-netifaces,
         python3-oauth,
         python3-oauthlib,
         python3-paramiko,
         python3-pexpect,
         python3-pyparsing,
         python3-pyvmomi,
         python3-seamicroclient,
         python3-simplejson,
         python3-simplestreams,
         python3-tempita,
         python3-twisted,
         python3-txtftp,
         python3-yaml,
         python3-zope.interface,
         isc-dhcp-client,
         iproute2,
         ${misc:Depends},
         ${python3:Depends}
Description: MAAS server provisioning libraries (Python 3)
 This package provides the MAAS provisioning server python libraries.
 .
 This package contains Python 3 libraries.

Package: maas-cli
Architecture: all
Depends: python3-maas-client (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends}
Conflicts: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Replaces: maas-region-controller-min (<= 1.5+bzr1909-0ubuntu1)
Description: MAAS client and command-line interface
 This package contains the 'maas' command-line interface, which
 talks to the MAAS region controller REST API. Use the maas command
 to login to MAAS and drive the data centre entirely from the
 command-line.

Package: python3-maas-client
Section: python
Architecture: all
Depends: python3-httplib2,
         python3-oauth,
         ${misc:Depends},
         ${python3:Depends}
Breaks: python-maas-client, maas-cli ( <= 2.0.0~alpha4+bzr4843-0ubuntu1 )
Replaces: python-maas-client, maas-cli ( <= 2.0.0~alpha4+bzr4843-0ubuntu1 )
Description: MAAS python API client (Python 3)
 This package contains the MAAS client API Python modules.
 .
 This package contains Python 3 modules.

Package: maas-rack-controller
Architecture: all
Depends: authbind,
         bind9utils,
         distro-info,
         freeipmi-tools,
         grub-common,
         maas-cli (=${binary:Version}),
         maas-common (=${binary:Version}),
         maas-dhcp (=${binary:Version}),
         pxelinux | syslinux-common (<< 3:6.00~pre4+dfsg-5),
         python3-httplib2,
         python3-maas-provisioningserver (=${binary:Version}),
         python3-netaddr,
         python3-tempita,
         python3-twisted,
         python3-zope.interface,
         rsyslog,
         syslinux-common,
         tgt,
         uuid-runtime,
         wget,
         ${misc:Depends},
         ${python3:Depends}
Suggests: amtterm, ipmitool, libvirt-bin, wsmancli
Conflicts: tftpd-hpa
Breaks: python-maas-provisioningserver,
        maas-cluster-controller
Replaces: python-maas-provisioningserver,
          maas-cluster-controller
Description: Rack Controller for MAAS
 The MAAS rack controller (maas-rackd) provides highly available, fast
 and local broadcast services to the machines provisioned by MAAS. You
 need a MAAS rack controller attached to each fabric (which is a set of
 trunked switches). You can attach multiple rack controllers to these
 physical networks for high availability, with secondary rack controllers
 automatically stepping to provide these services if the primary rack
 controller fails.
 .
 A common configuration is to have a rack controller in each rack, with
 a fast primary network interface to the rack switch and secondary
 network interfaces on one or two other nearby racks for high
 availability redundancy.
 .
 This package depends on the necessary components to provide iSCSI,
 DHCP, TFTP and power management.

Package: python3-django-maas
Section: python
Architecture: all
Depends: python3-apt,
         python3-convoy,
         python3-crochet,
         python3-curtin (>> 0.1.0~bzr275),
         python3-lxml,
         python3-maas-client (= ${binary:Version}),
         python3-netaddr,
         python3-psycopg2,
         python3-sphinx,
         python3-tempita,
         python3-twisted,
         python3-zope.interface,
         ${misc:Depends},
         ${python3:Depends}
Breaks: python-django-maas
Replaces: python-django-maas
Description: MAAS server Django web framework (Python 3)
 This package provides the Django web framework for MAAS.
 .
 This package contains Python 3 modules.

Package: maas-dhcp
Architecture: all
Depends: isc-dhcp-server (>= 4.3.3-5ubuntu10~), ${misc:Depends}
Description: MAAS DHCP server
 This package installs and configures a DHCP server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-dns
Architecture: all
Depends: bind9 (>= 1:9.10.3.dfsg.P2-5~),
         maas-region-api (= ${binary:Version}),
         ${misc:Depends}
Conflicts: dnsmasq
Description: MAAS DNS server
 This package installs and configures a DNS server that can be used by
 MAAS, and enhances the overall MAAS user experience.

Package: maas-proxy
Architecture: all
Depends: squid3, ${misc:Depends}
Conflicts: squid-deb-proxy
Description: MAAS Caching Proxy
 This package installs and configures a Caching Proxy server that can be
 used by MAAS. It enhances the overall MAAS user experience.

Package: maas-region-udeb
Package-Type: udeb
Section: debian-installer
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
XB-Installer-Menu-Item: 2350
Description: Install a MAAS server (installer integration)

Package: maas-rack-udeb
Package-Type: udeb
Section: debian-installer
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
XB-Installer-Menu-Item: 2350
Description: Install a MAAS Rack controller (installer integration)

## maas 2.0.0~beta3+bzr4941

=== debian/changelog ===
maas (2.0.0~beta3+bzr4941-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 beta 3 bzr4941 (Standing FFe LP: #1553261)
  * Remove some leftover references to Cluster.
  * Run debconf-updatepo.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 20 Apr 2016 13:21:39 -0400

maas (2.0.0~beta2+bzr4920-0ubuntu2) xenial; urgency=medium

  * debian/control: Add missing dep on python3-httplib2

 -- Andres Rodriguez <andreserl@ubuntu.com>  Fri, 15 Apr 2016 22:23:55 -0400

maas (2.0.0~beta2+bzr4920-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 beta 2 bzr4920 (Standing FFe LP: #1553261)
  * Only create the squid cache if we have a configuration file.
    LP: #1568847
  * Re-add shared debconf templates.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Thu, 07 Apr 2016 18:22:00 -0400

maas (2.0.0~beta1+bzr4873-0ubuntu2) xenial; urgency=medium

  * Add maas-region-udeb and maas-rack-udeb to be used as part of the
    Ubuntu Server Installer (LP: #1561954)
    - ensure maas-rack-controller and maas-region-controller can be fully
      preseeded.

 -- Andres Rodriguez <andreserl@ubuntu.com>  Tue, 05 Apr 2016 17:02:32 -0400

maas (2.0.0~beta1+bzr4873-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 beta 1 bzr4873 (Standing FFe LP: #1553261)
    - DHCP Snippets WebUI.
    - Ensure proxy configuration ACL's subnets MAAS knows about.
    - DNS High Availability.
  * debian/control: Move 'maascli' package install to
    python3-maas-client (LP: #1563859)
  * Improve way on how upgrades ensures correct permissions
    and ownership (LP: #1563799 , LP: #1563779)
  * Improve the way how removals clean the system (LP: #1563337)
  * Reflect new names and website for systemd units (LP: #1563807)
  * maas-proxy now uses a custom-built config, instead of a boilerplate.
    LP: #1379567

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 28 Mar 2016 16:47:58 -0400

maas (2.0.0~alpha4+bzr4843-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 alpha 4 bzr4843 (Standing FFe LP: #1553261)
    - DHCP Snippets backend and API.
    - Rack controller WebUI Served VLANs & Service Tracking
    - Rsyslog during enlistment/commissioning.
  * Ensure /etc/maas/templates/power gets removed on upgrade
  * debian/control: Update homepage and package descriptions.
    (LP: #1562036, LP: #1562034, LP: #1562062)
  * Rename maas-reigon-controller-min to maas-region-api (LP: #1562069)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Wed, 23 Mar 2016 12:27:27 -0400

maas (2.0.0~alpha3+bzr4810-0ubuntu1) xenial; urgency=medium

  * New upstream release, 2.0.0 bzr 4810 (Standing FFe LP: #1553261)
    - New Networks WebUI
      + Add Fabrics and Spaces details page.
      + Actions to Add/Remove Fabrics, VLANs, Spaces, Subnets.
    - Storage WebUI
      + Mount options
      + Swap Partitions
    - WebUI to change a Machine's domain.
    - Rack Controller details page now shows 'Server VLANs'
    - Add maas-rack support-dump command.
    - Fixes:
      + python3-maas-client API 2.0 no loger use op but MAASClient.post
        requires it (LP: #1555393)
      + Fail to commission when Fabric on Machine Interface doesn't match
        Rack Controller Fabric. (LP: #1554566)
      + TFTP back-end crashes (LP: #1553848)
      + Can't deploy a node, no interfaces on rack controller (LP: #1554999)
  * Update dhcpd permissions to conform with most recent paranoia described
    on LP: 1543794, so capability dac_override is not granted.
  * Update versioned depend on isc-dhcp-server

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 14 Mar 2016 18:34:53 -0400

maas (2.0.0~alpha2+bzr4776-0ubuntu1) xenial; urgency=medium

  * New usptream release, 2.0.0 bzr 4776 (LP: #1553261).
  * maas-dns Depends: bind9 >= 1:9.10.3.dfsg.P2-5 for better system time.
    LP: #1553176.
  * debian/extras/maas-{region,rack}: Replace maas-region-admin
    and maas-provision, respectively (LP: #1553791)
  * debian/maas-region-controller.postrm: Correctly handle removal by
    dbconfig-common. (LP: #1553648)
  * debian/extras/99-maas-region-sudoers: Allow running systemctl for
    bind9 and maas-proxy to support service tracking. (LP: #1555308)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 01 Feb 2016 18:18:52 +0100

maas (2.0.0~alpha1+bzr4736-0ubuntu1) xenial; urgency=medium

  * New usptream release, 2.0.0 bzr 4736 (LP: #1553261):
    - Deprecate Cluster Controllers in favor of Rack Controllers.
    - Deprecate API 1.0 in favor if API 2.0.
    - DHCP & Rack Controller High Availability.
    - Networking - IP Ranges.
    - Networking - DNS.
    - BMC Model.
  * Rename maas-cluster* to maas-rack* and handle the upgrade path.
  * Fix installation of init scripts and daemon systemd units.
  * Allow 'dhcpd' to access /usr/sbin/maas-provision via
    sudoers file (LP: #1552775)
  * debian/extras/maas: Replace shell wrapper with python. (LP: #1553605)
  * debian/control: Depends on iproute2 instead. (LP: #1553647)

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 01 Feb 2016 18:18:52 +0100

maas (1.10.0+bzr4572-0ubuntu2) xenial; urgency=medium

  * debian/maas-region-controller.config: Ensure we truly preseed db
    setting so we always use localhost and it never asks the user.
  * debian/control: Suggests on python3-pyvmomi

 -- Andres Rodriguez <andreserl@ubuntu.com>  Mon, 01 Feb 2016 17:04:27 +0100

maas (1.10.0+bzr4572-0ubuntu1) xenial; urgency=medium

  * New upstram release, 1.10.0 bzr 4572:
    - Support python3, drop support for python2.
    - Support django 1.8+.
  * debian/control:
    - Remove all Upstart related services.
    - Remove python-django16 dependency.
    - Add python-petname dependency.
    - Change dependency python-django-piston to python-django-piston3.
    - Depends on dbconfig-pgsql instead of dbconfig-common.
  * debian/maas-region-controller.config:
    - Preseed dbconfig common to not ask for PG server to use.
  * debian/maas-region-controller-min.maas-regiond-worker@.service: Don't


=== debian/rules ===
#!/usr/bin/make -f

BUILDHOME = $(CURDIR)/debian/build
PYTHON3 = $(shell py3versions -d)
# Python enum modules.
py_enums := $(wildcard src/*/enum.py)

%:
	dh $@ --with python3,apport,systemd --buildsystem=pybuild

override_dh_auto_test:
	# do nothing as we don't want the tests to run because they require
	# internet access

override_dh_installinit:
	dh_installinit -p maas-region-api --name=maas-regiond --no-start
	dh_installinit -p maas-region-api --name=maas-regiond-worker@  --no-start
	dh_installinit -p maas-rack-controller --name=maas-rackd
	dh_installinit -p maas-proxy --name=maas-proxy
	dh_installinit -p maas-dhcp --name=maas-dhcpd
	dh_installinit -p maas-dhcp --name=maas-dhcpd6

override_dh_systemd_enable:
	dh_systemd_enable -p maas-region-api --name=maas-regiond
	dh_systemd_enable -p maas-rack-controller --name=maas-rackd
	dh_systemd_enable -p maas-proxy --name=maas-proxy
	dh_systemd_enable -p maas-dhcp --name=maas-dhcpd
	dh_systemd_enable -p maas-dhcp --name=maas-dhcpd6

override_dh_systemd_start:
	dh_systemd_start -p maas-region-api --no-start maas-regiond.service
	dh_systemd_start -p maas-rack-controller maas-rackd.service
	dh_systemd_start -p maas-proxy maas-proxy.service
	dh_systemd_start -p maas-dhcp maas-dhcpd.service
	dh_systemd_start -p maas-dhcp maas-dhcpd6.service

override_dh_auto_build:
	dh_auto_build

	mkdir -p $(BUILDHOME)
	HOME=$(BUILDHOME) PYTHONPATH=$(CURDIR)/src/ $(PYTHON3)	\
		$(CURDIR)/src/maasserver/utils/jsenums.py	\
		$(py_enums) > $(BUILDHOME)/enums.js

override_dh_auto_install:
	dh_auto_install

	# Move static files
	install -d -m 755  $(CURDIR)/debian/tmp/usr/share/maas/web/static
	mv $(CURDIR)/debian/tmp/usr/lib/python*/*-packages/maasserver/static \
                $(CURDIR)/debian/tmp/usr/share/maas/web/

	# Remove scss directory from static files
	rm -rf $(CURDIR)/debian/tmp/usr/share/maas/web/scss

	# Install built enums.js file.
	cp $(BUILDHOME)/enums.js $(CURDIR)/debian/tmp/usr/share/maas/web/static/js/

	# install the apparmor profile
	install -d -m 755 $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d
	install -m 644 $(CURDIR)/debian/maas-dhcp.apparmor \
	    $(CURDIR)/debian/tmp/etc/apparmor.d/dhcpd.d/maas

	# install python3 twisted plugins
	set -ex; for python in $(PYTHON3); do \
		dh_install twisted/plugins/maasregiond.py usr/lib/$$python/dist-packages/twisted/plugins -pmaas-region-api; \
		dh_install twisted/plugins/maasrackd.py usr/lib/$$python/dist-packages/twisted/plugins -pmaas-rack-controller; \
	done

	dh_install --list-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDHOME)
	rm -rf src/*.egg-info

DEB_DEBIAN_DIR=$(dir $(firstword $(MAKEFILE_LIST)))
REV=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: .*[+~]bzr([0-9]+).*,\1,p')
VER=$(shell dpkg-parsechangelog -l$(DEB_DEBIAN_DIR)/changelog \
              | sed -rne 's,^Version: ([^-]+).*,\1,p')
get-orig-source:
	bzr export -r $(REV) --root=maas-$(VER).orig \
             maas_$(VER).orig.tar.gz lp:maas
